package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.MarketMap;
import com.izouma.awesomeadmin.service.MarketMapService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/marketMap")
public class MarketMapController {

    @Autowired
    private MarketMapService marketMapService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(MarketMap record) {
        List<MarketMap> pp = marketMapService.getMarketMapList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getMarketMap", method = RequestMethod.GET)
    @ResponseBody
    public Result getMarketMap(@RequestParam(required = false, value = "id") String id) {
        MarketMap data = marketMapService.getMarketMapById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(MarketMap record) {
        MarketMap data = marketMapService.getMarketMap(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, MarketMap record) {
        Map<String, Object> result = new HashMap<>();

        List<MarketMap> pp =marketMapService.getMarketMapByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(MarketMap record) {
        boolean num = marketMapService.createMarketMap(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateMarketMap(MarketMap record) {
        boolean num = marketMapService.updateMarketMap(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteMarketMap(MarketMap record) {

        boolean num = marketMapService.deleteMarketMap(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, MarketMap record) throws Exception {

    List<MarketMap> marketMaps = marketMapService.getMarketMapList(record);


        String sheetName = "market_map";
        String titleName = "地图信息表数据表";
        String fileName = "地图信息表表";
        int columnNumber = 22;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "编号" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "策划备注" ,   "地图类型" ,   "地图名称" ,   "缩略图" ,   "识别图信息" ,   "模式" ,   "识别图数据名称" ,   "地图信息" ,   "地图高" ,   "地图高" ,   "比率" ,   "是否显示" ,   "经度" ,   "纬度" ,   "辐射范围" ,   "城市"  };
        String[][] dataList = new String[marketMaps.size()][22];

        for (int i = 0; i < marketMaps.size(); i++) {

                        dataList[i][0] = String.valueOf(marketMaps.get(i).getId());
                        dataList[i][1] = String.valueOf(marketMaps.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(marketMaps.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(marketMaps.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(marketMaps.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(marketMaps.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(marketMaps.get(i).getRemark());
                        dataList[i][7] = String.valueOf(marketMaps.get(i).getMapType());
                        dataList[i][8] = String.valueOf(marketMaps.get(i).getMapName());
                        dataList[i][9] = String.valueOf(marketMaps.get(i).getMapSprite());
                        dataList[i][10] = String.valueOf(marketMaps.get(i).getAnchorImageGroupName());
                        dataList[i][11] = String.valueOf(marketMaps.get(i).getDefaultMode());
                        dataList[i][12] = String.valueOf(marketMaps.get(i).getVuforiaDataName());
                        dataList[i][13] = String.valueOf(marketMaps.get(i).getMapInfo());
                        dataList[i][14] = String.valueOf(marketMaps.get(i).getMapWidth());
                        dataList[i][15] = String.valueOf(marketMaps.get(i).getMapHeight());
                        dataList[i][16] = String.valueOf(marketMaps.get(i).getMapRate());
                        dataList[i][17] = String.valueOf(marketMaps.get(i).getShowInPanel());
                        dataList[i][18] = String.valueOf(marketMaps.get(i).getLatitude());
                        dataList[i][19] = String.valueOf(marketMaps.get(i).getLongitude());
                        dataList[i][20] = String.valueOf(marketMaps.get(i).getRadiantRange());
                        dataList[i][21] = String.valueOf(marketMaps.get(i).getCity());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

